#include "V_D_UC.h"

#ifdef USE_agent

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* CALL:
*   #include "V.h"
*   daPrsPath(name,srvr,file)
*   	char* name;
*   	Str*  srvr;
*   	Str*  file;
*
* DESCRIPTION:
*
* This routine takes a file name, and  tries  to  parse  it  into  two
* portions:   one a server; the other is the remainder, a file name to
* be passed to the server.
*
* The return value is 1 for success, 0 for failure. We also set errno.
*
* AUTHOR: John Chambers.
*
* CHANGES:
*/
FCT	daPrsPath(name,srvr,file)
	char* name;
	Str*  srvr;
	Str*  file;
{	int   r=0;
	int   e=errno;
	char* sp;	/* Server pointer */
	char* cp;	/* Char pointer */
:f	Fenter("daPrsPath");
:2	ChkNull(name,"File name");
:2	ChkNull(srvr,"Server");
:2	ChkNull(file,"File");
:5	V5D "Called for %s",Dspp(name) D;
	if (Streqn(name,"/../",4)) {
:5		V5D "TNC syntax." D;
		if (sp = Strchr(name+4,'/')) {
:5			V5D "TNC file is %s",Dspp(sp+1) D;
			if (!MakStrM(srvr,name+4,sp-name-4,"srvr")) Fail;
			if (!MakStrM(file,sp+1,-1,"file")) Fail;
			Done;
		}
	}
	if (cp = Strchr(name,'!')) {
:5		V5D "UUCP syntax." D;
		if (!(sp = Strchr(name,'/'))) {
:5			V5D "UUCP syntax with no '/'." D;
			sp = name;
		} else if (cp < sp) {
:5			V5D "UUCP syntax with '/' after '!'." D;
			sp = name;
		} else {
:5			V5D "Rejecting %s because '/' before '!'.",Dspp(name) D;
			sp = 0;
		}
		if (sp) {
			if (!MakStrM(srvr,sp,cp-sp,"srvr")) Fail;
			if (!MakStrM(file,cp+1,-1,"file")) Fail;
			Done;
		}
	}
	if (cp = Strchr(name,':')) {
:5		V5D "BSD syntax." D;
		if (!(sp = Strchr(name,'/'))) {
:5			V5D "BSD syntax with no '/'." D;
			sp = name;
		} else if (cp < sp) {
:5			V5D "BSD syntax with '/' after ':'." D;
			sp = name;
		} else {
:5			V5D "Rejecting %s because '/' before ':'.",Dspp(name) D;
			sp = 0;
		}
		if (sp) {
			if (!MakStrM(srvr,sp,cp-sp,"srvr")) Fail;
			if (!MakStrM(file,cp+1,-1,"file")) Fail;
			Done;
		}
	}
:5	V5D "Can't parse %s (local?)",Dspp(name) D;
	if (!CpyStrM(srvr,&NullStr,"srvr")) Fail;
	if (!MakStrM(file,name,-1,"file")) Fail;
done:
:5	V5D "srvr=%s file=%s",DspSP(srvr),DspSP(file) D;
	r = 1;
fail:
:f	Fexit;
	errno = e;
	return r;
}
#endif /* USE_agent */
