
/*
* CALL:
*   byte* bshift(ptr,len,off)
*   	byte *ptr;
*   	int	  len;
*   	int	  off;
*
* DESCRIPTION:
*
* Shift the len bytes at ptr by off bytes.  If off > 0, the  shift  is
* "right", i.e., to a higher address. If off < 0, the shift is "left",
* i.e., to a lower address.  If len or off is zero, this routine  does
* nothing at all.
*
* The  return value is ptr+off, i.e., the address to which the data is
* moved.
*
* BUGS:
*
* No  attempt  is  made  to  validate the addresses; if you get a SEGV
* fault, it's your own fault.  (Wouldn't it be marvelous if  the  nice
* folks  who  brought  us  Unix would deign to supply a system call to
* validate a pointer?  We all know that the kernel can do it ...  ;-)
*
* AUTHOR: John Chambers
*
*/
#include "V.h"

byte* bshift(ptr,len,off)
	byte *ptr;
	Sizt  len;
	Sizt  off;
{	byte *old, *new;
	if (off > 0) {		/* Right shift - do it right to left */
		new = (old = ptr + len - 1) + off;
		while (len--) *new-- = *old--;
	} else if (off < 0) {	/* Left shift - do it left to right */
		new = (old = ptr) + off;
		while (len--) *new++ = *old++;
	}
	return(ptr+off);	/* Original returned junk */
}

byte* d_bshift(ptr,len,off)
	byte *ptr;
	Sizt  len;
	Sizt  off;
{	byte *val;
	V6 "bshift(%08X,%d,%d)",ptr,len,off D;
	val = (BP)bshift(ptr,len,off);
	return(val);	/* Original returned junk */
}
