:i	static char d_strdup_sccs_id[] = "%W% %G%";
:1#include "V_M_UC.h"
#include "mem.h"
/*
* Allocate space for a copy of a null-terminated string, copy it to the new
* block, and return its address.  The m is for diagnostics.
*/
char* d_strdup(p,m)
	char *p, *m;
{	char *r=0;
	int   n;
:f	Fenter("d_strdup");
:8	V8M "Called with p=%08X m=%08X",p,m D;
	if (!m) m = unknown;
	if (!p) {
:2		V2 "### Warning: called with null pointer." D;
		Fail;
	}
	n = strlen(p) + 1;
	n = MEMUNIT(n);
:7	V7M "Get %d bytes for \"%s\"",n,m D;
	if (r = (char*)GetChunk(n,m)) {
:8		V8M "Got %d bytes  for %s.",n,m D;
		Bcopy(p, r, n);
:7		V7M "Put %d bytes into %s.",n,m D;
	}
fail:
:f	Fexit;
	return r;
}
/*
* Here's a similar function that allows you to specify a length, which we will
* calculate if you send -1.  Note that we grab an extra byte and null-fill it.
*/
char* d_strdupn(p,n,m)
	char *p, *m;
	int   n;
{	char *r;
:f	Fenter("d_strdupn");
	if (!m) m = unknown;
	if (n < 0) n = strlen(p);
	if (r = (char*)GetChunk(MEMUNIT(n+1),m)) {
:9		V9M "Got %d bytes  for %s.",n+1,m D;
		Bcopy(p, r, n);
		p[n] = 0;	/* Null-terminate it */
:9		V9M "Put %d bytes into %s.",n+1,m D;
	}
:f	Fexit;
	return r;
}
